/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#include "elistaddbuttondesignerplugin.h"
#include "elistaddbuttondesignerplugin.moc"

#include "elistaddbutton.h"

EListAddButtonDesignerPlugin::EListAddButtonDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString EListAddButtonDesignerPlugin::name() const
{
	return "EListAddButton";
}

QString EListAddButtonDesignerPlugin::group() const
{
	return "Elements (Meganizer)";
}

QString EListAddButtonDesignerPlugin::toolTip() const
{
	return "EListAddButton subclasses MPushButton and displays a plus icon by default";
}

QString EListAddButtonDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString EListAddButtonDesignerPlugin::includeFile() const
{
	return "elistaddbutton.h";
}

QIcon EListAddButtonDesignerPlugin::icon() const
{
	return QIcon();
}

bool EListAddButtonDesignerPlugin::isContainer() const
{
	return false;
}

QWidget* EListAddButtonDesignerPlugin::createWidget(QWidget* parent)
{
	return new EListAddButton(parent);
}

QString EListAddButtonDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"EListAddButton\" name=\"eListAddButton\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Preferred\" vsizetype=\"Preferred\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";;
}

void EListAddButtonDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	if(isInitialized())
		return;
	
	initialized = true;
}

bool EListAddButtonDesignerPlugin::isInitialized() const
{
	return initialized;
}
