/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mdialogdesignerplugin.h"

#include "mdialog.h"

MDialogDesignerPlugin::MDialogDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MDialogDesignerPlugin::name() const
{
	return "MDialog";
}

QString MDialogDesignerPlugin::group() const
{
	return "Container (EngSaS)";
}

QString MDialogDesignerPlugin::toolTip() const
{
	return "MDialog subclasses QDialog and provides more extended functionalities.";
}

QString MDialogDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MDialogDesignerPlugin::includeFile() const
{
	return "mdialog.h";
}

QIcon MDialogDesignerPlugin::icon() const
{
	return QIcon();
}

bool MDialogDesignerPlugin::isContainer() const
{
	return true;
}

QWidget* MDialogDesignerPlugin::createWidget(QWidget* parent)
{
	return new MDialog(parent);
}

QString MDialogDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MDialog\" name=\"MDialog\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"MinimumExpanding\" vsizetype=\"MinimumExpanding\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";;
}

void MDialogDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MDialogDesignerPlugin::isInitialized() const
{
	return initialized;
}

#include "mdialogdesignerplugin.moc"
