/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mpushbuttondesignerplugin.h"

#include "mpushbutton.h"

MPushButtonDesignerPlugin::MPushButtonDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MPushButtonDesignerPlugin::name() const
{
	return "MPushButton";
}

QString MPushButtonDesignerPlugin::group() const
{
	return "Elements (Meganizer)";
}

QString MPushButtonDesignerPlugin::toolTip() const
{
	return "A replacement of QPushButton, which handle QIcon::fromTheme via setIcon()";
}

QString MPushButtonDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MPushButtonDesignerPlugin::includeFile() const
{
	return "mpushbutton.h";
}

QIcon MPushButtonDesignerPlugin::icon() const
{
	return QIcon();
}

bool MPushButtonDesignerPlugin::isContainer() const
{
	return false;
}

QWidget* MPushButtonDesignerPlugin::createWidget(QWidget* parent)
{
	return new MPushButton(parent);
}

QString MPushButtonDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MPushButton\" name=\"mPushButton\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Preferred\" vsizetype=\"Preferred\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";;
}

void MPushButtonDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MPushButtonDesignerPlugin::isInitialized() const
{
	return initialized;
}

#include "mpushbuttondesignerplugin.moc"
