/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mwidgetdesignerplugin.h"

#include "mwidget.h"

MWidgetDesignerPlugin::MWidgetDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MWidgetDesignerPlugin::name() const
{
	return "MWidget";
}

QString MWidgetDesignerPlugin::group() const
{
	return "Container (EngSaS)";
}

QString MWidgetDesignerPlugin::toolTip() const
{
	return "MWidget subclasses QWidget and provides more extended functionalities (like MDialog).";
}

QString MWidgetDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MWidgetDesignerPlugin::includeFile() const
{
	return "mwidget.h";
}

QIcon MWidgetDesignerPlugin::icon() const
{
	return QIcon();
}

bool MWidgetDesignerPlugin::isContainer() const
{
	return true;
}

QWidget* MWidgetDesignerPlugin::createWidget(QWidget* parent)
{
	return new MWidget(parent);
}

QString MWidgetDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MWidget\" name=\"MWidget\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Expanding\" vsizetype=\"Expanding\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";;
}

void MWidgetDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MWidgetDesignerPlugin::isInitialized() const
{
	return initialized;
}

#include "mwidgetdesignerplugin.moc"
