/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#include "searchbuttondesignerplugin.h"

#include "searchbutton.h"

SearchButtonDesignerPlugin::SearchButtonDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString SearchButtonDesignerPlugin::name() const
{
	return "SearchButton";
}

QString SearchButtonDesignerPlugin::group() const
{
	return "Elements (Meganizer)";
}

QString SearchButtonDesignerPlugin::toolTip() const
{
	return "SearchButton subclasses MPushButton and displays a binocular icon by default";
}

QString SearchButtonDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString SearchButtonDesignerPlugin::includeFile() const
{
	return "searchbutton.h";
}

QIcon SearchButtonDesignerPlugin::icon() const
{
	return QIcon();
}

bool SearchButtonDesignerPlugin::isContainer() const
{
	return false;
}

QWidget* SearchButtonDesignerPlugin::createWidget(QWidget* parent)
{
	return new SearchButton(parent);
}

QString SearchButtonDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"SearchButton\" name=\"searchButton\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Preferred\" vsizetype=\"Preferred\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";;
}

void SearchButtonDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	if(isInitialized())
		return;
	
	initialized = true;
}

bool SearchButtonDesignerPlugin::isInitialized() const
{
	return initialized;
}

#include "searchbuttondesignerplugin.moc"
