/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "dbupdatewidget.h"

#include "sqlinit.h"

DBUpdateWidget::DBUpdateWidget ( QString title, SqlInit* newDBInit, SetupWizardObject* newObject, QWidget* parent, Qt::WindowFlags flags )
    : SetupWizardWidget ( newObject, parent, flags )
{
  setupUi ( this );
  setName ( title );
  sqlInit = newDBInit;
}

DBUpdateWidget::DBUpdateWidget (SqlInit* newDBInit, SetupWizardObject *newObject, QWidget *parent, Qt::WindowFlags flags )
    : SetupWizardWidget ( newObject, parent, flags )
{
  setupUi ( this );
  setName ( tr ( "Checking the database structure" ) );
	sqlInit = newDBInit;
}

DBUpdateWidget::~DBUpdateWidget()
{

}

bool DBUpdateWidget::finish()
{
	if(!sqlInit)
		return false;
	
  connectByPass ( sqlInit );
  connect ( sqlInit, SIGNAL ( actualStep ( QString ) ), this, SLOT ( actualStep ( QString ) ) );
  connect ( sqlInit, SIGNAL ( finishedStep() ), this, SLOT ( finishedStep() ) );
  connect ( sqlInit, SIGNAL ( neededSteps ( int ) ), this, SLOT ( setRange ( int ) ) );
  if ( sqlInit->login ( false, true ) != SqlInit::NoUpdateNeeded )
    return false;

  return true;
}

bool DBUpdateWidget::saveSettings()
{
  return true;
}

void DBUpdateWidget::errorByPass(const QString& string)
{
	log(string);
}

void DBUpdateWidget::warningByPass(const QString& string)
{
	log(string);
}

void DBUpdateWidget::informationByPass(const QString& string)
{
	log(string);
}

void DBUpdateWidget::setRange ( int num )
{
  progressBar->setRange ( 0, num );
}

void DBUpdateWidget::finishedStep()
{
  progressBar->setValue ( progressBar->value() + 1 );
}

void DBUpdateWidget::actualStep ( QString msg )
{
  stepLabel->setText ( msg );
}

void DBUpdateWidget::log ( QString msg )
{
  logEdit->appendPlainText ( msg );
}

#include "dbupdatewidget.moc"
