/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef DBUPDATEWIDGET_H
#define DBUPDATEWIDGET_H

#include "libmacro.h"

#include "setupwizardwidget.h"
#include "ui_dbupdatewidget.h"

class SqlInit;

#include <QPointer>

class EXPORT_DLL DBUpdateWidget : public SetupWizardWidget, private Ui::DBUpdateUi
{
    Q_OBJECT
  public:
    DBUpdateWidget ( SqlInit *newDBInit, SetupWizardObject *newObject = 0, QWidget *parent = 0, Qt::WindowFlags flags = 0 );
    DBUpdateWidget ( QString title, SqlInit *newDBInit, SetupWizardObject *newObject = 0, QWidget *parent = 0, Qt::WindowFlags flags = 0 );
    ~DBUpdateWidget();

  public slots:
    bool finish();
    bool saveSettings();

  private slots:
		void errorByPass ( const QString &string );
    void warningByPass ( const QString &string );
		void informationByPass ( const QString &string );
		
    void setRange ( int num );
    void finishedStep();
    void actualStep ( QString msg );
    void log ( QString msg );

  private:
    QPointer<SqlInit> sqlInit;
};

#endif // DBUPDATEWIDGET_H
