/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MATERIALPERSON_H
#define MATERIALPERSON_H

#include "libmacro.h"
#include <person.h>

class EXPORT_DLL MaterialPerson : public Person
{
  Q_OBJECT
  public:
    MaterialPerson(QObject *parent = 0);
    MaterialPerson(unsigned int personId, unsigned int roleId, unsigned int rowId = 0, QObject *parent = 0);
    MaterialPerson(QString newName, QString newGivenName, unsigned int roleId, QObject *parent = 0);
		MaterialPerson(QString newName, QString newGivenName, QString role, QObject *parent = 0);
    
    bool store(unsigned int materialId);
		void setRowId(unsigned int rowId);
		unsigned int rowId() const;
		bool preparePerson();
    void setRole(unsigned int newId, bool setName = true);
		void setRole(QString name, bool setId = true);
    unsigned int role() const;
		bool prepareRole();
		QString roleName() const;
		MaterialPerson *copyPerson();
		
    bool operator== ( const MaterialPerson &matPerson) const;
    
  private:
    void initMatP();
    bool insert(unsigned int materialId);
    bool remove(unsigned int materialId);
    
    QString myRole;
    unsigned int myRoleId, myRowId;
};

#endif // MATERIALPERSON_H
