/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEDIUMGIFTWIDGET_H
#define MEDIUMGIFTWIDGET_H

#include "libmacro.h"
#include <mwidget.h>
#include "ui_mediumgiftwidget.h"

class Medium;
class PersonsModel;
class Person;

/**
	* @todo handle medium changed() signal
	* @todo enable transactions again, but make sure, that they are only used, if they are not destroying another transaction
	*/
class EXPORT_DLL MediumGiftWidget : public MWidget, private Ui::MediumGiftWidget
{
	Q_OBJECT
	public:
		MediumGiftWidget(Medium *medium, QWidget *parent = 0, Qt::WindowFlags flags = 0);
		MediumGiftWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setMedium(Medium *medium);
		bool store();
		
	private slots:
		void setGiftOnly();
		void addPresentees();
		void removePresentees();
		void presenteeContextMenu(QPoint pos);
		void giftGiven();
		void giftNotGiven();
		void userSelected(QModelIndex index);
		void userDoubleClicked(QModelIndex index);
		void presenteeSelected(QModelIndex index);
		void presenteeDoubleClicked(QModelIndex index);
	
	private:
		void init();
		
		Medium *medium;
		PersonsModel *userModel, *presenteesModel;
		QModelIndex userIndex, presenteesIndex;
		QList<Person*> givenGift;
};

#endif // MEDIUMGIFTWIDGET_H
