/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#ifndef MEDIUMLISTPRICEWIDGET_H
#define MEDIUMLISTPRICEWIDGET_H

#include "libmacro.h"
#include <mwidget.h>
#include "ui_mediumpricewidget.h"

class Medium;

class QSqlQueryModel;

class EXPORT_DLL MediumListPriceWidget : public MWidget, private Ui::MediumPriceWidget
{
	Q_OBJECT
	public:
		MediumListPriceWidget(Medium *medium, QWidget *parent = 0, Qt::WindowFlags flags = 0);
		MediumListPriceWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setMedium(Medium *medium);
		
	private slots:
		void setPrice();
		void setCurrency();
		void loadFromMedium();
	
	private:
		void init();
		void loadCompleter();
		
		Medium *medium;
		QSqlQueryModel *complModel;
		QMap<unsigned int, QString> mapCurrencies;
};

#endif // MEDIUMLISTPRICEWIDGET_H
