/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEDIUMMINWIDGET_H
#define MEDIUMMINWIDGET_H

#include "libmacro.h"

#include <mwidget.h>
#include "ui_mediumminwidget.h"

class Medium;

class QLineEdit;
class QComboBox;

class EXPORT_DLL MediumMinWidget : public MWidget, private Ui::MediumMinWidget
{
	Q_OBJECT
	public:
		MediumMinWidget(Medium *medium, QWidget *parent = 0, Qt::WindowFlags flags = 0);
		MediumMinWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setMedium(Medium *medium);
		void setDefaultMinType(unsigned int typeId);
		void setDefaultMinType(QString name);
		
	private slots:
		void setMin();
		void newMIN();
		void removeMIN();
		void newMINType();
		void selectionChanged(QModelIndex index);

	private:
		void init();
		
		Medium *medium;
		QLineEdit *minEdit;
		QComboBox *minType;
		unsigned int defaultType;
};

#endif // MEDIUMMINWIDGET_H
