/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumwishwidget.h"

#include "medium.h"

MediumWishWidget::MediumWishWidget(Medium* medium, QWidget* parent, Qt::WindowFlags flags)
	: MWidget(parent, flags)
{
	init();
	setMedium(medium);
}

MediumWishWidget::MediumWishWidget(QWidget* parent, Qt::WindowFlags flags)
	: MWidget(parent, flags)
{
	init();
	setMedium(0);
}

void MediumWishWidget::setMedium(Medium* medium)
{
	if(this->medium)
		medium->disconnect(this);
	this->medium = medium;
	
// 	if(medium)
// 		connect(medium, SIGNAL(cahnged()), this, SLOT(setWishFromMedium()));
	
	bool enable = true;
	if(!medium)
		enable = false;
	setEnabled(enable);
	setWishFromMedium();
}

void MediumWishWidget::setWish()
{
	if(!medium)
		return;
	
	medium->setWish(checkEdit->isChecked());
}

void MediumWishWidget::setWishFromMedium()
{
	if(medium)
		checkEdit->setChecked(medium->wish());
}

void MediumWishWidget::init()
{
	this->medium = 0;
	setupUi(this);
	checkLabel->setText(tr("Wish:"));
	connect(checkEdit, SIGNAL(stateChanged(int)), this, SLOT(setWish()));
}

#include "mediumwishwidget.moc"
