/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#include "modulelistwidgetitem.h"

ModuleListWidgetItem::ModuleListWidgetItem ( QListWidget *parent, int type ) :
    QListWidgetItem ( parent, type )
{
	init();
}

ModuleListWidgetItem::ModuleListWidgetItem ( QString text, QListWidget * parent, int type ) :
    QListWidgetItem ( text, parent, type )
{
	init();
}

ModuleListWidgetItem::ModuleListWidgetItem ( QIcon icon, QString text, QListWidget *parent, int type ) :
    QListWidgetItem ( icon, text, parent, type )
{
	init();
}

ModuleListWidgetItem::ModuleListWidgetItem ( QListWidgetItem other ) : QListWidgetItem ( other )
{
init();
}

void ModuleListWidgetItem::setName ( QString name )
{
  setText ( name );
}

QString ModuleListWidgetItem::name() const
{
  return text();
}

void ModuleListWidgetItem::setFile ( QString file )
{
  myFile = QFileInfo ( file );
  if ( text().isEmpty() )
    setText ( myFile.baseName() );
}

QString ModuleListWidgetItem::file() const
{
  return myFile.absoluteFilePath();
}

void ModuleListWidgetItem::setStatus ( bool status )
{
  if ( !status ) {
    setIcon ( QIcon ( ":/icons/notok.png" ) );
  }
  else {
    setIcon ( QIcon ( ":/icons/ok.png" ) );
  }
  myStatus = status;
}

bool ModuleListWidgetItem::status() const
{
  return myStatus;
}

void ModuleListWidgetItem::setErrorMessage ( QString message )
{
  myErrorMessage = message;
}

QString ModuleListWidgetItem::errorMessage() const
{
  return myErrorMessage;
}

void ModuleListWidgetItem::setDescription ( QString description )
{
  myDescription = description;
}

QString ModuleListWidgetItem::description() const
{
  return myDescription;
}

void ModuleListWidgetItem::setModuleIcon ( QIcon modIcon )
{
	myModuleIcon = modIcon;
}

QIcon ModuleListWidgetItem::moduleIcon() const
{
	return myModuleIcon;
}

bool ModuleListWidgetItem::operator==(const ModuleListWidgetItem& item) const
{
	if(!item.file().isEmpty() || file().isEmpty()){
		if(item.file() == file())
			return true;
	}
	
	return false;
}

bool ModuleListWidgetItem::operator!=(const ModuleListWidgetItem& item) const
{
	return !operator==(item);
}

void ModuleListWidgetItem::init()
{
  setName ( QString() );
  setFile ( QString() );
  setErrorMessage ( QString() );
  setDescription ( QString() );
  setStatus ( false );
}
