/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef PERSONSMODEL_H
#define PERSONSMODEL_H

#include "libmacro.h"
#include <QAbstractItemModel>

class Person;

#include <QModelIndex>

class QTableView;

class EXPORT_DLL PersonsModel : public QAbstractItemModel
{
  Q_OBJECT
  public:
    PersonsModel(QObject *parent = 0);
    ~PersonsModel();
    
    // own API
		void addPerson(Person *person);
    virtual Person *addPerson();
		Person *addPerson(unsigned int personId);
		Person *addPerson(QString name, QString givenName);
		Person *addPerson(unsigned int personId, QString name, QString givenName);
    Person *personFromIndex(QModelIndex index) const;
		virtual QModelIndex indexFromPerson(Person *person);
		virtual void hideColumns(QTableView *view);
		Person *takePerson(Person *person);
		Person *takePerson(QModelIndex index);
    
    // QT API
    virtual QVariant data(const QModelIndex& index, int role = Qt::DisplayRole) const;
		virtual bool setData ( const QModelIndex& index, const QVariant& value, int role = Qt::EditRole );
    virtual int columnCount(const QModelIndex& parent = QModelIndex()) const;
    int rowCount(const QModelIndex& parent = QModelIndex()) const;
    QModelIndex parent(const QModelIndex& child) const;
    QModelIndex index(int row, int column, const QModelIndex& parent = QModelIndex()) const;
    virtual QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
  
	protected slots:
    void itemChanged(Person *person);
		
	protected:
    QList<Person*> items;
};

#endif // PERSONSMODEL_H
