/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef PROGRESSSTATUSWIDGET_H
#define PROGRESSSTATUSWIDGET_H

#include "libmacro.h"
#include "mwidget.h"
#include "ui_progressstatuswidget.h"

class EXPORT_DLL ProgressStatusWidget : public MWidget, private Ui::ProgressStatusWidget
{
	Q_OBJECT
	public:
    ProgressStatusWidget(QWidget* parent = 0, Qt::WindowFlags flags = 0);
		bool wasCanceled();
		
	public slots:
		void setRange(int min, int max);
		void setValue(int value);
		int value();
		void setFormat(QString format);
		void setLabel(QString text);
		void removeMe();
		
	private slots:
		void cancel();
		
	private:
		bool myWasCanceled;
		
	signals:
		void canceled();
};

#endif // PROGRESSSTATUSWIDGET_H
