/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef QUERYWORKER_H
#define QUERYWORKER_H

#include "mobject.h"

#include "msqldatabase.h"

#include <QSqlQuery>
#include <QSqlRecord>

class QueryWorker : public MObject
{
	Q_OBJECT
	public:
    QueryWorker(QObject* parent = 0);
    virtual ~QueryWorker();
		
	public slots:
		void configureDB(QString dbname, QString username, QString password, QString host, QString driver);
		void addToQueue(QString queryString, QList<QVariant> bindValues);
		void cancel();
		
	private:
		bool abort;
		QString connectionName;
		
	signals:
		void result(QSqlRecord record);
		void setRange(int min, int max);
		void setValue(int value);
		void finished(bool status);
};

#endif // QUERYWORKER_H
