/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "setupwizarddbdump.h"

#include <dbbackup.h>
#include "sqllogin.h"
#include "msqldatabase.h"

SetupWizardDBDump::SetupWizardDBDump(QObject* parent)
	: SetupWizardObject(parent)
{
	setTitle(tr("Backup Database"));
}

QList< SetupWizardWidget* > SetupWizardDBDump::wizardWidgets()
{
	QList<SetupWizardWidget*> list;
	list << new DBBackup(this);
	return list;
}


bool SetupWizardDBDump::finish(SetupWizardWidget* finishWidget)
{
	if(finishWidget->finish())
		return true;
	return false;
}

bool SetupWizardDBDump::needed()
{
	// we can not do anything, if the database isn't set up correctly
	SqlLogin login;
	connectByPass(&login);
	if(!login.checkSettings())
		return false;
	
	if(login.exec() != QDialog::Accepted)
		return false;
	login.disconnect(this);
	this->disconnect(&login);
	
	MSqlDatabase db = MSqlDatabase::database();
	QStringList objects;
	objects <<  db.tables(QSql::Tables) << db.tables(QSql::Views);
	if(objects.size() > 0)
		return true;
	
	return false;
}

#include "setupwizarddbdump.moc"
