/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef SETUPWIZARDOBJECT_H
#define SETUPWIZARDOBJECT_H

#include "libmacro.h"

#include "mobject.h"

class SetupWizardWidget;

class EXPORT_DLL SetupWizardObject : public MObject
{
    Q_OBJECT
  public:
    SetupWizardObject ( QObject *parent = 0 );
    virtual ~SetupWizardObject();
    QString title();

    virtual bool needed() = 0;
    virtual bool finish ( SetupWizardWidget *finishWidget ) = 0;
    virtual QList<SetupWizardWidget*> wizardWidgets() = 0;

  protected:
    void setTitle ( QString newTitle );

  private:
    QString myTitle;

};

#endif // SETUPWIZARDOBJECT_H
