/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef BOOK_H
#define BOOK_H

#include "medium.h"

#include <QDate>

class Book : public Medium
{
	Q_OBJECT
  public:
    Book ( Medium *parent = 0 );

		Medium *newMedium();
    bool select( QSqlRecord record);
    bool select ( unsigned int searchId, unsigned int userId = 0 );
    bool store(bool addOwner = false, bool startTransaction = true);
    bool setValue ( QString attribute, QVariant value );
    QVariant value ( QString attribute, int role );
    EditMedium *editWidget(MWidget* parent = 0);

    void setPages ( unsigned int newPages );
    unsigned int pages();
    void setEdition ( unsigned int newEdition );
    unsigned int edition();
    void setPublicationPlace ( QString newPlace );
    QString publicationPlace();
    void setPublicationDate ( QDate newDate );
    QDate publicationDate();

		Medium *copyMedium();
		bool exportMedium(QTextTable *table, Medium::ExportFormat format, bool titleOnly = false);

		QList<ColKeyTrans> supportedAttrs();
		
  private:
    unsigned int myPages;
    unsigned int myEdition;
    QString myPublicationPlace;
    QDate myPublicationDate;
};

#endif // BOOK_H
