/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "movies.h"
#include "movies.moc"

#include "setupwizardobject.h"
#include "setupwizarddb.h"
#include "moviesdb.h"
#include "moviesmodel.h"
#include "moviesearchwidget.h"
#include "movie.h"

#include <QtPlugin>
#include <QStringList>
#include <QIcon>

Movies::Movies ( QObject *parent ) : MediaPlugin()
{

}

Movies::~Movies()
{

}

bool Movies::initiate ()
{
  return true;
}

bool Movies::unload ()
{
  return true;
}

QString Movies::name ()
{
  return myName();
}

QString Movies::myName()
{
	return tr ( "Movie" );
}

QString Movies::group()
{
  return "movies";
}

QIcon Movies::icon ()
{
  return QIcon();
}

QString Movies::description ()
{
  return tr ( "Plugin is able to handle media Movies" );
}

MediaModel *Movies::newModel ( QString materialType, QueryThread *thread )
{
	return new MoviesModel ( thread, this );
}

SearchDetailsWidget *Movies::searchWidget ( QString materialType )
{
	return new MovieSearchWidget();
}

bool Movies::store ()
{
  return false;
}

bool Movies::load ()
{
  return false;
}

QStringList Movies::supportedAttributes ( QString materialType )
{
	Movie med;
	return med.supportedAttributes();
}

SettingsWidget *Movies::settingsWidget ()
{
  return 0;
}

SetupWizardObject *Movies::wizardObject()
{
  return new SetupWizardDB ( tr ( "Configure Database of Movies" ), new MoviesDB ( ), this );
}

QStringList Movies::supportedMaterialTypes()
{
  QStringList result;
  result << tr ( "Movie" );
  return result;
}

void Movies::show ()
{

}

void Movies::settingsChanged ()
{

}

void Movies::print ()
{

}

void Movies::save ()
{

}

void Movies::doExport ()
{

}

void Movies::redo ()
{

}

void Movies::undo ()
{

}

void Movies::cut ()
{

}

void Movies::copy ()
{

}

void Movies::paste ()
{

}

void Movies::reload ()
{

}

void Movies::reloadSettingsByPass ()
{

}

Q_EXPORT_PLUGIN2 ( Meganizer_Movies, Movies )
