/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "cds.h"

#include "setupwizardobject.h"
#include "setupwizarddb.h"
#include "cdsdb.h"
#include "cdsmodel.h"
#include "tracksmodel.h"
#include "cdsearchwidget.h"
#include "cd.h"
#include "track.h"

#include <QtPlugin>
#include <QStringList>
#include <QIcon>

CDs::CDs ( QObject *parent ) : MediaPlugin()
{

}

CDs::~CDs()
{

}

bool CDs::initiate ()
{
  return true;
}

bool CDs::unload ()
{
  return true;
}

QString CDs::name ()
{
  return myName();
}

QString CDs::myName()
{
	return tr ( "Music" );
}

QString CDs::group()
{
  return "cds";
}

QIcon CDs::icon ()
{
  return QIcon();
}

QString CDs::description ()
{
  return tr ( "Plugin is able to handle media like audio CD's or DVD's (...) and tracks" );
}

MediaModel *CDs::newModel ( QString materialType, QueryThread *thread )
{
	MediaModel *model = 0;
	if(materialType == tr ( "Music Device" ))
		model = new CDsModel ( thread, this );
	if(materialType == tr ( "Track" ))
		model = new TracksModel ( thread, this );
  return model;
}

SearchDetailsWidget *CDs::searchWidget ( QString materialType )
{
	if(materialType == tr ( "Music Device" ))
		return new CDSearchWidget();
	return 0;
}

bool CDs::store ()
{
  return false;
}

bool CDs::load ()
{
  return false;
}

QStringList CDs::supportedAttributes ( QString materialType )
{
	if(materialType == tr( "Music Device" )){
		CD cd;
		return cd.supportedAttributes();
	}
	if(materialType == tr ( "Track" )){
		Track track;
		return track.supportedAttributes();
	}
	return QStringList();
}

SettingsWidget *CDs::settingsWidget ()
{
  return 0;
}

SetupWizardObject *CDs::wizardObject()
{
  return new SetupWizardDB ( tr ( "Configure Database of Audio CDs" ), new CDsDB ( ), this );
}

QStringList CDs::supportedMaterialTypes()
{
  QStringList result;
  result << tr ( "Music Device" );
	result << tr ( "Track" );
  return result;
}

void CDs::show ()
{

}

void CDs::settingsChanged ()
{

}

void CDs::print ()
{

}

void CDs::save ()
{

}

void CDs::doExport ()
{

}

void CDs::redo ()
{

}

void CDs::undo ()
{

}

void CDs::cut ()
{

}

void CDs::copy ()
{

}

void CDs::paste ()
{

}

void CDs::reload ()
{

}

void CDs::reloadSettingsByPass ()
{

}

#include "cds.moc"

Q_EXPORT_PLUGIN2 ( Meganizer_CDs, CDs )
