/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "parentview.h"

#include <medium.h>
#include <mediamodel.h>
#include "tracksmodel.h"
#include "track.h"
#include <msqldatabase.h>

#include <QSqlQuery>

ParentView::ParentView(QWidget* parent, Qt::WindowFlags flags)
	: MWidget(parent, flags)
{
	setupUi(this);
}

void ParentView::setMedium(Medium* child)
{
	Track *track = qobject_cast<Track*>(child);
	if(!track)
		return;
	view->setModel(0);

	MSqlDatabase db = MSqlDatabase::database();
	bool closeDB = !db.isOpen();
	if(closeDB)
		db.open();
	if(!db.isOpen())
		return;
	
	TracksModel *tracks = track->tracks();
	// build up list of child id's
	QStringList whereStrings;
	whereStrings << QString("hasMaterialsId=%1").arg(track->id());
	for(int i = 0; i < tracks->rowCount(); i++){
		Medium *med = tracks->mediumFromIndex(tracks->index(i, 0));
		if(med)
			whereStrings << QString("hasMaterialsId=%1").arg(med->id());
	}
	QString inString = "SELECT materialsId FROM materialhasmaterials WHERE "+ whereStrings.join(" OR ");
	QSqlQuery query;
	// exclude ourselve, beacuse otherwise, we may list as related media, because we are listed at our child's
	// as a parent
	query.exec("SELECT * FROM viewmaterials WHERE id IN ("+ inString +") AND id<>"+ QString::number(track->id()));
	MediaModel *model = new MediaModel(0, this);
	while(query.next()){
		model->addMedium(query.record());
	}
	if(closeDB)
		db.close();
	
	model->configureView(view);
}


#include "parentview.moc"
