/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef TRACKSVIEW_H
#define TRACKSVIEW_H

#include <mwidget.h>

class TracksModel;
class EListAddButton;
class EListRemoveButton;
class ETableView;

#include <QModelIndex>

class TracksView : public MWidget
{
	Q_OBJECT
	public:
		TracksView(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setModel(TracksModel *model);
		
	private slots:
		void addTrack();
		void addTrack(unsigned int trackId);
		void removeTrack();
		void selectTrack(QModelIndex index);
		
	private:
		QModelIndex index;
		TracksModel *model;
		EListAddButton *addTrackButton;
		EListRemoveButton *delTrackButton;
		ETableView *view;
};

#endif // TRACKSVIEW_H
