/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "about.h"

#include "openfileexternal.h"

#include <QSettings>

About::About ( QWidget* parent, Qt::WindowFlags flags ) : MDialog ( parent, flags )
{
	setupUi(this);
	
	connect(label, SIGNAL(linkActivated(QString)), this, SLOT(openLink(QString)));
	
	QSettings settings;
	QString shortName = settings.value("appNameShort").toString();
  QString appTitle = settings.value("appName").toString();
  QString appWWW = settings.value("appWWW").toString();
  QString appVersion = settings.value("appVersion").toString();
  QString prodName = settings.value("prodName").toString();
  QString prodWWW = settings.value("prodWWW").toString();
  QString prodMail = settings.value("prodMail").toString();
	
	label->setText(QString(
										"<table>"
										"	<tr><th colspan=\"2\"><h3>%1</h3></th></tr>"
										"	<tr><td>"+ tr("Version:") +"</td><td>%2</td></tr>"
										"	<tr><td>"+ tr("Homepage:") +"</td><td><a href=\"%3\">%3</a></td></tr>"
										" <tr><th colspan=\"2\" height=\"0.1em\">&nbsp;</td></tr>"
										"	<tr><td>"+ tr("Manufacturer:") +"</td><td>%4</td></tr>"
										"	<tr><td>"+ tr("Homepage:") +"</td><td><a href=\"%5\">%5</a></td></tr>"
										"</table>"
										)
										.arg(appTitle)
										.arg(appVersion)
										.arg(appWWW)
										.arg(prodName)
										.arg(prodWWW)
									 );
}

void About::openLink(QString url)
{
	OpenFileExternal openFile(this);
	connectByPass(&openFile);
	openFile.openFile(url);
}

#include "about.moc"
