/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef MODULESTATE_H
#define MODULESTATE_H

#include "mwidget.h"

#include "modulelistwidgetitem.h"

namespace Ui
{
  class ModuleState;
}

/**
  * shows some information about the loading process of each found module
  */
class ModuleState : public MWidget
{
    Q_OBJECT
  public:
    ModuleState ( QList<ModuleListWidgetItem*> newProtocol, QWidget *parent = 0 );
    ~ModuleState();
		void setViewOnly();

  protected:
    void changeEvent ( QEvent *e );

  private slots:
    void itemClicked ( QListWidgetItem *item );
    void loadButton();
    void unloadButton();
    void reloadButton();

  private:
    Ui::ModuleState *ui;
    QList<ModuleListWidgetItem*> protocol;
    ModuleListWidgetItem *activeItem;

    void convertProtocol();

  signals:
    void reloadPlugins();
    void unload ( ModuleListWidgetItem* item );
    void load ( ModuleListWidgetItem* item, bool emitSetupWizard );
};

#endif // MODULESTATE_H
