/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef SEARCHWIDGET_H
#define SEARCHWIDGET_H

#include "mwidget.h"
#include "ui_searchwidget.h"
#include "querythread.h"

class MediaPlugin;
class SearchPlugin;
class ShoppingCart;
class ResultSummary;
class MINValidator;

#include <QModelIndex>
#include <QPointer>

class QSqlQueryModel;

class SearchWidget : public MWidget, private Ui::SearchWidget
{
    Q_OBJECT
  public:
    SearchWidget ( QWidget *parent = 0, Qt::WindowFlags flags = 0 );
    ~SearchWidget();
		/**
			* setting the defaultType let fail the restoreGeometry
			*/
    void init ( QList<MediaPlugin*> newMediaPlugins, QList<SearchPlugin*> newSearchPlugins, ShoppingCart *shoppingCart );

  private slots:
    void typeChanged ( QString text );
    void search();
		void reloadForeignKeys();
		void setupQueryThread();

  private:
    void connectModel(QObject *model);
    
    QList<MediaPlugin*> mediaPlugins;
    QList<SearchPlugin*> searchPlugins;
    QMap <int, QString> typeMap, userMap;
    unsigned int ownUserId;
		ShoppingCart *shoppingCart;
		QList<QSqlQueryModel*> completerModels;
		QSqlQueryModel *manuModel, *genreModel;
		QueryThread *queryThread;
		QPointer<ResultSummary> resSum;
		MINValidator *minValidator;
};

#endif // SEARCHWIDGET_H
