/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef SETTINGSGENERAL_H
#define SETTINGSGENERAL_H

#include <settingswidget.h>

class DBSettings;
class SetupUserWidget;

#include <QSettings>
#include <QCloseEvent>

namespace Ui {
    class SettingsGeneral;
}

/**
  * @todo provide tooltip entrys for each setting
  */
class SettingsGeneral : public SettingsWidget {
  Q_OBJECT
  public:
    SettingsGeneral(QWidget *parent = 0, Qt::WindowFlags flags = 0);
    SettingsGeneral(bool showButtons, QWidget *parent = 0, Qt::WindowFlags flags = 0) __attribute__ ((deprecated));
    ~SettingsGeneral();

  public slots:
    bool saveSettings();

  protected:
    void changeEvent(QEvent *e);
    void closeEvent(QCloseEvent *event);

  private slots:
    void searchPluginDir();
    void loadSettings();
    void saveQuit();;

  private:
    QSettings qSettings;
    Ui::SettingsGeneral *m_ui;
		DBSettings *dbSettings;
		SetupUserWidget *userWidget;
		/**
			* @todo check wether the analyze of qm files is better
			*/
    void init();

  signals:
    void ready();
};

#endif // SETTINGSGENERAL_H
