/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "demoshop.h"

#include <mediamodel.h>
#include <medium.h>
#include <settingswidget.h>
#include <setupwizardobject.h>

#include <QtPlugin>
#include <QTime>

DemoShop::DemoShop ( QObject* parent ) : SearchPlugin()
{
}

DemoShop::~DemoShop()
{
}

bool DemoShop::initiate()
{
  return true;
}

bool DemoShop::unload()
{
  return true;
}

QString DemoShop::name() const
{
  return tr ( "DemoShop" );
}

QString DemoShop::group()
{
  return "demoshop";
}

QString DemoShop::settingsGroup()
{
  return group();
}

QIcon DemoShop::icon()
{
  return QIcon ( ":/demoshop/demoshop.png" );
}

QString DemoShop::description()
{
  return tr ( "DemShop is used to test features and to visualize possible new features" );
}

QMap<QString, QString> DemoShop::supportedAttributes()
{
  QMap<QString, QString> attrs;
  return attrs;
}

QMap<QString, QString> DemoShop::supportedCategories()
{
  QMap<QString, QString> cats;
  return cats;
}

SettingsWidget* DemoShop::settingsWidget()
{
  return 0;
}

SetupWizardObject* DemoShop::wizardObject()
{
  return 0;
}

bool DemoShop::search ( MediaModel* resultModel, QList<SqlConstraint> sqlConstraints )
{
  return false;
}

void DemoShop::recieveBuyData ( Medium *medium )
{
	if(!medium)
		return;
	
	QTime midnight(0, 0, 0);
	qsrand(midnight.msecsTo(QTime::currentTime()));
	
	int numBuyDatas = qrand() % 5;
	for(int i = 0; i < numBuyDatas; i++){
		float tmp1 = qrand() % 10;
		float tmp2 = qrand() % 5 * 10;
		float tmp3 = qrand() % 3;

		if(tmp3 == 0)
			tmp3 = 0.124;
	
		BuyData data;
		data.medium = medium;
		data.shop = this;
		data.price = tmp1 * tmp2 / tmp3;
		data.inCatalog = true;
		data.currencyShortName = "EUR";
		data.available = tmp1;
	
		int isUsed = qrand() % 10;
		if(isUsed > 5)
			data.isUsed = true;
		
		data.shippingCost = qrand() % 20;
		emit foundBuyData(data);
	}
}

bool DemoShop::purchase ( QList< BuyData > items, QMap<Medium*, int> quantities )
{
	return true;
}

bool DemoShop::operator== ( const SearchPlugin& plugin ) const
{
  if(name() == plugin.name())
    return true;
  return false;
}

bool DemoShop::operator!= ( const SearchPlugin& plugin ) const
{
  if(operator==(plugin))
    return false;
  return true;
}

void DemoShop::show()
{

}

void DemoShop::settingsChanged ()
{

}

void DemoShop::print ()
{

}

void DemoShop::save ()
{

}

void DemoShop::doExport ()
{

}

void DemoShop::redo ()
{

}

void DemoShop::undo ()
{

}

void DemoShop::cut ()
{

}

void DemoShop::copy ()
{

}

void DemoShop::paste ()
{

}

void DemoShop::reload ()
{

}

void DemoShop::reloadSettingsByPass ()
{

}

#include "demoshop.moc"

Q_EXPORT_PLUGIN2 ( Meganizer_DemoShop, DemoShop )
